unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, mysql51conn, sqldb, db, Grids, ExtCtrls, InterfaceBase, LCLIntf, lcltype;

type

  { TForm1 }

  { TMyDBGrid }

  TMyDBGrid = class(TCustomDBGrid)
  public
     procedure PrepareCanvas(aCol,aRow: Integer; aState:TGridDrawState); override;
     procedure DrawCell(aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);override;
     function  GetBufferCount: integer;
     property RowHeights;


     property BorderColor;
     property Canvas;
     property DefaultTextStyle;
     property EditorBorderStyle;
     property EditorMode;
     property ExtendedColSizing;
     property FastEditing;
     property FocusColor;
     property FocusRectVisible;
     property GridLineColor;
     property GridLineStyle;
     property SelectedColor;
     property SelectedRows;
   published
     property Align;
     property AlternateColor;
     property Anchors;
     property AutoAdvance default aaRightDown;
     property AutoEdit;
     property AutoFillColumns;
     property BorderSpacing;
     property BorderStyle;
     property Color;
     property Columns; // stored false;
     property Constraints;
     property DataSource;
     property DefaultDrawing;
     property DefaultRowHeight;
     property DragCursor;
     property DragMode;
     property Enabled;
     property FixedColor;
     property FixedCols;
     property FixedHotColor;
     property Flat;
     property Font;
     property HeaderHotZones;
     property HeaderPushZones;
     property Options;
     property OptionsExtra;
     property ParentColor default false;
     property ParentFont;
     property PopupMenu;
     property ReadOnly;
     property Scrollbars default ssBoth;
     property ShowHint;
     property TabOrder;
     property TabStop;
     property TitleFont;
     property TitleImageList;
     property TitleStyle;
     property UseXORFeatures;
     property Visible;
     property OnCellClick;
     property OnColEnter;
     property OnColExit;
     property OnColumnMoved;
     property OnColumnSized;
     property OnContextPopup;
     property OnDrawColumnCell;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEditButtonClick;
     property OnEditingDone;
     property OnEndDrag;
     property OnEnter;
     property OnExit;
     property OnFieldEditMask;
     property OnKeyDown;
     property OnKeyPress;
     property OnKeyUp;
     property OnMouseDown;
     property OnMouseEnter;
     property OnMouseLeave;
     property OnMouseMove;
     property OnMouseUp;
     property OnPrepareCanvas;
     property OnSelectEditor;
     property OnStartDrag;
     property OnTitleClick;
     property OnUserCheckboxBitmap;
     property OnUTF8KeyPress;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

  procedure CalculateTextRect(style : TTextStyle; str : String; var fRect : TRect; DC : HDC);



var
  Form1: TForm1;
  conn : TMySQL51Connection;
  ds : TDataSource;
  q : TSQLQuery;
  tr : TSQLTransaction;
  grid : TMyDBGrid;
implementation

{ TMyDBGrid }

procedure CalculateTextRect(style : TTextStyle; str : String; var fRect : TRect; DC : HDC);
var
  Options : Longint;
begin

  Options := 0;
  case Style.Alignment of
    taRightJustify : Options := DT_RIGHT;
    taCenter : Options := DT_CENTER;
  end;
  case Style.Layout of
    tlCenter : Options := Options or DT_VCENTER;
    tlBottom : Options := Options or DT_BOTTOM;
  end;
  if Style.WordBreak then
    Options := Options or DT_WORDBREAK;

  if Style.SingleLine then
    Options := Options or DT_SINGLELINE;

  if not Style.Clipping then
    Options := Options or DT_NOCLIP;

  if Style.ExpandTabs then
    Options := Options or DT_EXPANDTABS;

  if not Style.ShowPrefix then
    Options := Options or DT_NOPREFIX;

  if Style.RightToLeft then
    Options := Options or DT_RTLREADING;

  if Style.Clipping then
  begin
    Options := Options or DT_NOCLIP;
  end;

  WidgetSet.DrawText(DC, pChar(str), Length(str), fRect, DT_CALCRECT or Options);

end;

procedure TMyDBGrid.PrepareCanvas(aCol, aRow: Integer; aState: TGridDrawState);
var
  style : TTextStyle;
  r : TRect;
  f : TField;
  iCol : Integer;
  TextHeight : Integer;
begin
  if (aCol <> 0) and (aRow <> 0) then
  begin
    inherited PrepareCanvas(aCol, aRow, aState);
    style.SingleLine:= False;
    style.Wordbreak:=True;
    Canvas.TextStyle := style;
    f := GetFieldFromGridColumn(aCol);
    iCol := GetGridColumnFromField(f);
    r.Left := 0;
    r.Top := 0;
    r.Right := Columns[0].Width;
    r.Bottom := 30;
    CalculateTextRect(style,f.DisplayText,r,Canvas.Handle);
    TextHeight := r.Bottom - r.Top;
    if TextHeight <= 20 then TextHeight := 30;
    RowHeights[aRow] := TextHeight;
  end
  else
  begin
    inherited PrepareCanvas(aCol, aRow, aState);
  end;
end;

procedure TMyDBGrid.DrawCell(aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);
begin
    inherited DrawCell(aCol, aRow, aRect, aState);
end;

function TMyDBGrid.GetBufferCount: integer;
begin
  Result := 30;
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  column : TColumn;
begin
  conn := TMySQL51Connection.Create(nil);
  conn.UserName:='<user>';
  conn.Password:='<password>';
  conn.HostName:='<ip>';
  conn.DatabaseName:='<database>';
  conn.CharSet:='UTF8';
  conn.Connected:=True;

  grid := TMyDBGrid.Create(Form1);
  column := grid.Columns.Add;
  column.FieldName:='title';
  column.Width:=170;
  grid.ScrollBars := ssVertical;

  Form1.InsertControl(grid);
  tr := TSQLTransaction.Create(nil);
  tr.DataBase := conn;
  q := TSQLQuery.Create(nil);
  q.DataBase := conn;
  q.SQL.Text := 'select title from documents';
  q.Transaction := tr;
  ds := TDataSource.Create(nil);
  ds.DataSet := q;
  grid.DataSource := ds;
  grid.Left:=10;
  grid.Top := 10;
  grid.Width := 400;
  grid.Height := 300;
  grid.Visible := True;
  q.Open;

end;


end.

